package com.tzld.piaoquan.risk.control.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.tzld.piaoquan.risk.control.common.base.CommonResponse;
import com.tzld.piaoquan.risk.control.config.QywxConfig;
import com.tzld.piaoquan.risk.control.model.qywx.QwCommonResModel;
import com.tzld.piaoquan.risk.control.model.qywx.QwInitResponseModel;
import com.tzld.piaoquan.risk.control.model.qywx.QwLoginCheckCode;
import com.tzld.piaoquan.risk.control.model.qywx.QwLoginQRCodeModel;
import com.tzld.piaoquan.risk.control.service.QwLoginService;
import com.tzld.piaoquan.risk.control.service.qywx.Constant;
import com.tzld.piaoquan.risk.control.util.HttpClientUtil;
import com.tzld.piaoquan.risk.control.util.HttpPoolClient;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

@RestController
@RequestMapping("/qw")
@Slf4j
public class QwLoginController {
    private static final HttpPoolClient httpPoolClientDefault = HttpClientUtil.create(10000, 10000, 2000, 5000, 5, 10000);
    @Autowired
    private QywxConfig qywxConfig; // 注入配置类
    @Autowired
    private QwLoginService qwLoginService;
    private static final Logger LOGGER = LoggerFactory.getLogger(QwLoginController.class);


    @PostMapping("/getQrCode")
    public CommonResponse<QwLoginQRCodeModel> getQrCode(@RequestBody String phoneNumber) {
        QwCommonResModel<QwLoginQRCodeModel> loginModel = qwLoginService.getLoginQRCode(phoneNumber);

        return CommonResponse.success(loginModel.getData());
    }

    @PostMapping("/checkQRCode ")
    public CommonResponse<String> checkQRCode(@RequestBody QwLoginCheckCode checkCode) {
        String url = Constant.QWDOMAIN + Constant.LOGIN_QRCODE_PATH;
        String response =  httpPoolClientDefault.postJson(url, JSON.toJSONString(checkCode)).toString();
        System.out.println("checkQRCode,response: " + response);
        if (response.contains("qrcode_not need verify")) {
            return CommonResponse.success("qrcode_not need verify");
        } else {
            return CommonResponse.success();
        }
    }

    @PostMapping("/automaticLogin")
    public CommonResponse<String> automaticLogin(@RequestBody QwLoginCheckCode checkCode) {
        String url = qywxConfig.getDomain() + qywxConfig.getPath("login-qrcode");
        String response =  httpPoolClientDefault.postJson(url, JSON.toJSONString(checkCode)).toString();
        System.out.println("checkQRCode,response: " + response);
        return CommonResponse.success();
    }

    @PostMapping("/quiteLogin")
    public CommonResponse<String> quiteLogin(@RequestBody String uuid) {
        String url = qywxConfig.getDomain() + qywxConfig.getPath("quit-login");
        String response =  httpPoolClientDefault.postJson(url, uuid).toString();
        System.out.println("quiteLogin,response: " + response);
        QwCommonResModel<QwLoginQRCodeModel> QRCODE = JSON.parseObject(response, new TypeReference<QwCommonResModel<QwLoginQRCodeModel>>() {});
        return CommonResponse.success();

    }


    @PostMapping("/checkLogin")//前端轮训检测是否登录成功
    public CommonResponse<String> checkLogin(@RequestBody String uuid) {
        if(true) {
            return new CommonResponse<>();
        } else if(false) {
            return CommonResponse.success();
        } else {
            return CommonResponse.success();
        }
//        String url = Constant.QWDOMAIN + Constant.LOGIN_QRCODE_PATH;
//        String response =  httpPoolClientDefault.postJson(url, uuid).toString();
//        QwLoginQRCodeModel QRCODE = JSON.parseObject(response, QwLoginQRCodeModel.class);
//        return CommonResponse.success("ok");
    }

}
